<?php
class additional_sections {
    function view() {
        if ( isset($_POST['action']) && $_POST['action'] == 'update' ) {
            $sections = array();
            $num_sections = stripslashes($_POST['num_sections']);
            for ($x=0; $x <= $num_sections; $x++) {
                $name = strtoupper($_POST["section_name_" . $x]);
                $title = stripslashes($_POST["section_title_" . $x]);
                $pub_date = stripslashes($_POST["pub_date_" . $x]);           
                $pages = stripslashes($_POST["section_pages_" . $x]);              
                
                if (($name) && ($title) && ($pub_date)) {
                    $sections[count($sections)+1] = array("name"=>$name, "title"=>$title, "pub_date"=>$pub_date, "pages"=>$pages);
                }
            }
            update_option("e_sections_additional_sections", serialize($sections));
        }
        
        $sections = get_option("e_sections_additional_sections", serialize(array()));
        if (!is_array($sections)) {
            $sections = unserialize($sections);
        }   
        
        $dates = array();
        foreach ($sections as $s) {
			$t = strtotime($s["pub_date"]);
			if (array_key_exists($t, $dates)) { $t += 1; }
            $dates[$t] = strtotime($s["pub_date"]);
        }
        array_multisort($dates, SORT_DESC, $sections);
       
?>
    <div class="wrap" id="e-section-wrap">
	    <div id="e-section-title">
	        <h2>E-Section - Additional Section</h2>
	    </div>
	</div>
    
    <div>
        <form method="post">
          <?php wp_nonce_field('update-options'); ?>
        
          <table class="widefat" style="width: 98%;">

          <tr>
          <th>Section Prefix</th>
          <th>Section Title</th>
          <th>Publication Date</th>
          <th>Number of Pages / Section</th>          
          </tr>
<?php

          for ($x = 0; $x < count($sections); $x++) {
              // do something
              $pages = $sections[$x]["pages"];
			  $t = mktime(0, 0, 0, date("m")  , date("d"), date("Y"));

              if (strtotime($sections[$x]["pub_date"]) < $t) {
                  $style = " style=\"color: lightgrey;\"";
              } else { $style = ""; }
?>
            <tr>
            <td><input type="text" name="section_name_<?php echo $x ?>" value="<?php echo $sections[$x]["name"] ?>" maxlength="3" <?php echo $style; ?>/></td>
            <td><input type="text" name="section_title_<?php echo $x ?>" value="<?php echo $sections[$x]["title"] ?>" <?php echo $style; ?>/></td>
            <td><input type="text" name="pub_date_<?php echo $x ?>" value="<?php echo $sections[$x]["pub_date"] ?>" class="date_picker" <?php echo $style; ?>/></td>            
            <td>
            <select name="section_pages_<?php echo $x ?>" <?php echo $style; ?>>
<?php
            for ($p=1; $p<=64; $p++) {
                if ($p == $pages) { $selected=" selected=selected"; }
                else { $selected = ""; }
                print "<option value=\"$p\"$selected>$p</option>";
            }
?>            
            </select>
            </td

            </tr>
<?php              
          }
          $next_section = count($sections);
?>
          <tr>
            <td><input type="text" name="section_name_<?php echo $next_section ?>" value="" maxlength="3"/></td>
            <td><input type="text" name="section_title_<?php echo $next_section ?>" value=""/></td>
            <td><input type="text" name="pub_date_<?php echo $next_section ?>" value="" class="date_picker"/></td>
            <td>
            <select name="section_pages_<?php echo $next_section ?>">
<?php
            for ($x=1; $x<=64; $x++) {
                print "<option value=\"$x\">$x</option>";
            }
?>            
            </select>
            </td
        </tr>
        <tr>
            <td colspan="4" style="text-align: center; font-size: 1.2em;">
                <input type="submit" value="Save Additional Sections"/>
            </td>
         </tr>
          
          
          </table>
          <input type="hidden" name="action" value="update" />
          <input type="hidden" name="num_sections" value="<?php echo $next_section ?>"/>
          
        </form>
    </div>
    
    <script type="text/javascript">
        jQuery.noConflict();  
        jQuery(document).ready(function() {
            jQuery('.date_picker').datepicker({
				dateFormat: 'M dd yy'
			});
        });
    </script>
<?php
    }    
}
?>