<?php
class print_tags {
    
    function print_tags_add_custom_box() {
        add_meta_box('printtagsdiv', __('Print Tags'), array(&$this, 'print_tags_meta_box'), 'post', 'side', 'low');
    }
    
    function view() {

        $print_tag_options = get_option('print_tag_options');
        
        if ( isset($_POST['action']) && $_POST['action'] == 'update' ) {

            $print_tag_options['number_of_sections'] = $_POST['number_of_sections'];
            for ($i = 1; $i <= $print_tag_options['number_of_sections']; $i++) {
                $print_tag_options['section_name_' . $i] = $_POST['section_name_' . $i];
                $print_tag_options['page_count_' . $i] = $_POST['page_count_' . $i];            
            }
            
			// clean up any old special section tags - they've since moved to separate option
			unset($print_tag_options['special_section_name']);
			unset($print_tag_options['special_section_title']);
			unset($print_tag_options['special_section_count']);
			unset($print_tag_options['special_section_name_1']);
			unset($print_tag_options['special_section_title_1']);
			unset($print_tag_options['special_section_count_1']);
			
            update_option('print_tag_options', $print_tag_options);		
            
            # make sure tags exist
            for ($i = 1; $i <= $print_tag_options['number_of_sections']; $i++) {
                $section = $print_tag_options['section_name_' . $i];
                for ($j = 1; $j <= $print_tag_options['page_count_' . $i]; $j++) {
                    $tag = $section . $j;
                    if (!term_exists($tag, 'post_tag')) {
                        $term = wp_insert_term($tag, 'post_tag');
                    }                    
                }
            }
    		echo '<div class="updated"><p>Print Tags Settings Updated</p></div>';
    	}
    	
    	
    ?>


        <div class="wrap" id="e-section-wrap">
    	    <div id="e-section-title">
    	        <h2>E-Section - Print Tags</h2>
    	    </div>
    	</div>
        
        <div>
        
        <form method="post">
        <?php wp_nonce_field('update-options'); ?>
        <input type="hidden" name="number_of_sections" value="4"/>
        <table class="form-table">

        <tr valign="top">
        <th scrope="row" style="width: 100px;">Section Name</th>
        <th scope="row">Pages</th>
        </tr>

        <tr valign="top">
        <td><input type="text" name="section_name_1" value="<?php echo $print_tag_options['section_name_1']; ?>" disabled="disabled"/></td>
        <td>
        <select name="page_count_1">
        <?php 
        $page_count_1 = $print_tag_options['page_count_1'];
        for ($i=1; $i <= 64; $i++) {
        ?>
            <option value="<?php echo $i; ?>"<?php if ($i == $page_count_1) { echo " selected"; }?>><?php echo $i; ?></option>
        <?php
        }
        ?>
        </select>
        </td>
        </tr>

        <tr valign="top">
        <td><input type="text" name="section_name_2" value="<?php echo $print_tag_options['section_name_2']; ?>" disabled="disabled"/></td>
        <td>
        <select name="page_count_2">
        <?php 
        $page_count_2 = $print_tag_options['page_count_2'];
        for ($i=1; $i <= 64; $i++) {
        ?>
        <option value="<?php echo $i; ?>"<?php if ($i == $page_count_2) { echo " selected"; }?>><?php echo $i; ?></option>
        <?php
        }
        ?>
        </select>
        </td>
        </tr>
        <tr valign="top">
        <td><input type="text" name="section_name_3" value="<?php echo $print_tag_options['section_name_3']; ?>" disabled="disabled"/></td>
        <td>
        <select name="page_count_3">
        <?php 
        $page_count_3 = $print_tag_options['page_count_3'];
        for ($i=1; $i <= 64; $i++) {
        ?>
        <option value="<?php echo $i; ?>"<?php if ($i == $page_count_3) { echo " selected"; }?>><?php echo $i; ?></option>
        <?php
        }
        ?>
        </select>
        </td>
        </tr>
        <tr valign="top">
        <td><input type="text" name="section_name_4" value="<?php echo $print_tag_options['section_name_4']; ?>" disabled="disabled"/></td>
        <td>
        <select name="page_count_4">
        <?php 
        $page_count_4 = $print_tag_options['page_count_4'];
        for ($i=1; $i <= 64; $i++) {
        ?>
           <option value="<?php echo $i; ?>"<?php if ($i == $page_count_4) { echo " selected"; }?>><?php echo $i; ?></option>
        <?php
        }
        ?>
        </select>
        </td>
        </tr>     
    
        </table>

        <input type="hidden" name="action" value="update" />
        <input type="hidden" name="page_options" value="section_name_1,page_count_1,section_name_2,page_count_2,section_name_3,page_count_3,section_name_4,page_count_4" />
        <input type="hidden" name="number_of_sections" value="4"/>
        <input type="hidden" name="section_name_1" value="A"/>
        <input type="hidden" name="section_name_2" value="B"/>
        <input type="hidden" name="section_name_3" value="C"/>
        <input type="hidden" name="section_name_4" value="D"/>
        <p class="submit">
        <input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
        </p>

        </form>
        </div>

        <script type="text/javascript">
            jQuery.noConflict();  
            jQuery(document).ready(function() {

                jQuery("input[name=number_of_sections]").change(function(event){
                    alert(event.target.value);
                });
            });
        </script>

    <?php
    }
    
    #
    function print_tags_meta_box() {
        global $post;
        $print_tag_options = get_option('print_tag_options');
        $sections = get_option("e_sections_additional_sections", serialize(array()));
        $pages = get_option("e_sections_spectal_section_pages", 20);
        if (!is_array($sections)) {
            $sections = unserialize($sections);
        }
    ?>
        <div id="print-tags">
        <style>
        .print-tag-section {
            font-size: 36px;
            font-weight: bold;
        }

        .print-tag-pages, .special-print-tag-pages {
            font-size: 16px;
            padding: 4px;
            margin: 2px;
        }
        </style>
        
            <table id="print-tag-table">
    <?php
            $print_tags = array();
            for ($i=1; $i<=$print_tag_options['number_of_sections']; $i++) {
    ?>
            <tr>
                <th class="print-tag-section">
                    <?php echo $print_tag_options['section_name_' . $i]; ?>
                </th>

                <td class="print-tag-pages">
    <?php
                for ($j=1; $j<=$print_tag_options['page_count_' . $i]; $j++) {
                    $tag = $print_tag_options['section_name_' . $i] . "-" . $j;
                    array_push($print_tags, $tag);
                    echo "<span id=\"" . $tag . "\" class=\"" . $tag . "\"> " . $j . " </span>";
                }
    ?>
                </td>
            </tr>
    <?php
            }
    ?>  
    
    <?php if ($sections) { ?>
    <tr>
        <td colspan="2"><strong>Additional Section: </strong> 
        <select name="special_section">
        <option value="">--- select ---</option>    
        <?php for ($x = 1; $x<=count($sections); $x++) {
            echo "<option value=\"" . strtolower($sections[$x]["name"]) ."\">". $sections[$x]["title"] . "</option>\n";
        } ?>
        </select>
                <tr id="special_section_pages" style="display: none;">
                    <th class="print-tag-section">S</th>

                    <td class="special-print-tag-pages">
                    <?php
/*                        for ($j=1; $j<=$pages; $j++) {
                            $tag = $j;
                            array_push($print_tags, $tag);
                            echo "<span id=\"" . $tag . "\"> " . $j . " </span>";
                        } */
                        
                    for ($x = 1; $x<=count($sections); $x++) {
                        echo "<div id=\"" . strtolower($sections[$x]["name"]) . "-pages\" class=\"ss-pages\" style=\"display: none;\">";
                        for ($j=1; $j<=$sections[$x]["pages"]; $j++) {
                            $tag = $j;
//                            array_push($print_tags, $tag);
                            echo "<span id=\"" . $tag . "\"> " . $j . " </span>";
                        }
                        echo "</div>";
                    }
                    ?>
                    </td>
                </tr>
    <?php } ?>
    

            <?php 
            if (get_post_meta($post->ID, "e_section_date", true)) {
                $print_tag_date = strftime("%b %d %Y", strtotime(get_post_meta($post->ID, "e_section_date", true))); 
            } else {
                $print_tag_date = strftime("%b %d %Y", time() + 86400);
            }
            ?>
            <tr>
            <td colspan="2"><span id="print_date">Print Date: <input type="text" class="date-pick" name="print-tag-date" value="<?php echo $print_tag_date; ?>"/></span></td>
            </tr>
            </table>

            <input type="hidden" name="print_tag" value=""/>

            <script type="text/javascript">
                jQuery.noConflict();
                jQuery(document).ready(function($){
                    $('select[name=special_section]').change(function() {
                     if ($(this).val()) {
                         $(".ss-pages").hide();
                         $("#special_section_pages").show();
                         $("#" + $(this).val() + "-pages").show();
                         $('input[name=print-tag-date]').attr('disabled','disabled');
                         $("#print_date").hide();
                         $(".special-print-tag-pages span").css("color", "black");
                         $(".special-print-tag-pages span").css("font-weight", "normal");
                        $(":input[name=print_tag]").val("");
                     } else {
                         $("#special_section_pages").hide();
                         $(".ss-pages").hide();
                         $('input[name=print-tag-date]').removeAttr('disabled');       
                         $(":input[name=print_tag]").val("");
                                         
                     }
                    });
                    $('input[name=print-tag-date]').datepicker({
    				dateFormat: 'M dd yy'
                			});
                    $(".print-tag-pages span").click(function(e) {
                        $(".print-tag-pages span").css("color", "black");
                        $("#" + e.target.id.toUpperCase()).css("color", "red");
                        $(".print-tag-pages span").css("font-weight", "normal");
                        $("#" + e.target.id).css("font-weight", "bold");
                        $(":input[name=print_tag]").val(e.target.id);
                        $('select[name=special_section]').val("");
                        $("#special_section_pages").hide();
                        $('input[name=print-tag-date]').removeAttr('disabled');                       
                        $("#print_date").show();
                    });

                    $(".special-print-tag-pages span").click(function(e) {
                        $(".special-print-tag-pages span").css("color", "black");
                        $(".ss-pages > span[id=" + e.target.id + "]").css("color", "red");
                        $(".print-tag-pages span").css("color", "black");
                        $(".print-tag-pages span").css("font-weight", "normal");                        
                        $(".special-print-tag-pages span").css("font-weight", "normal");
                        $(".ss-pages > span[id=" + e.target.id + "]").css("font-weight", "bold");                        
                        $(":input[name=print_tag]").val(e.target.id);
                    });

                    <?php
                    $section = get_post_meta($post->ID, 'e_section', true);
                    $page = get_post_meta($post->ID, 'e_section_page', true);

                    $tag = strtoupper($section . "-" .$page);
                    ?>
                    $("#<?php echo $tag; ?>").css("color", "red");
                    $("#<?php echo $tag; ?>").css("font-weight", "bold");
                    $(":input[name=print_tag]").val("<?php echo $tag ?>");
                    $('select[name=special_section]').val("<?php echo $section?>");
                    if ($('select[name=special_section]').val() != "") {
                        $("#" + $('select[name=special_section]').val() + "-pages").show();
                        $(".ss-pages > span[id=<?php echo $page ?>]").css("color", "red");
                        $(".ss-pages > span[id=<?php echo $page ?>]").css("font-weight", "bold");
                        $('input[name=print-tag-date]').attr('disabled','disabled');                
                        $("#print_date").hide();                        
                        $("#special_section_pages").show(); 
                        $(":input[name=print_tag]").val("<?php echo $page; ?>");
                    }
                });
            </script>
        </div>
    <?php
    }

    function print_tags_update_tags($post_id) {
        if ($_POST['action'] == 'editpost') {
            if ((isset($_POST['special_section'])) && ($_POST['special_section'] != "") && ($_POST['print_tag'])) {
                $sections = get_option("e_sections_additional_sections", serialize(array()));
                if (!is_array($sections)) {
                    $sections = unserialize($sections);
                }
                
                $section = "";
                for ($x = 1; $x <= count($sections); $x++) {
                    if (strtolower($sections[$x]["name"]) == strtolower($_POST['special_section'])) {
                        $section = $sections[$x];
                    }
                }          
                
                $print_tag = $_POST['special_section'] . $_POST['print_tag'];
                $form_tags = split(",", $_POST['tax_input']['post_tag']);
                $print_tags = $this->print_tags_load();
                $cleaned_form_tags = array();
                foreach ($form_tags as $form_tag) {
                    if (in_array($form_tag, $print_tags[0]) != 1) {
                        array_push($cleaned_form_tags, preg_replace("/-/", "", $form_tag));                   
                    }
                }
                array_push($cleaned_form_tags, strtoupper(preg_replace("/-/", "", $print_tag)));
                
                $ptag = preg_replace("/-/", "", $cleaned_form_tags);
                wp_set_post_terms($post_id, $cleaned_form_tags, 'post_tag');
                update_post_meta($post_id, 'e_section', strtolower($_POST['special_section']));
                update_post_meta($post_id, 'e_section_page', $_POST['print_tag']);
                
                update_post_meta($post_id, 'e_section_date', strftime("%Y-%m-%d", strtotime($section["pub_date"])));
                
                
            } else {
                if ((isset($_POST['print_tag'])) && ($_POST['print_tag'])) {
                   $print_tag = $_POST['print_tag'];
                   $form_tags = split(",", $_POST['tax_input']['post_tag']);
                   $print_tags = $this->print_tags_load();
                   $cleaned_form_tags = array();
                   foreach ($form_tags as $form_tag) {
                       if (in_array(strtoupper($form_tag), $print_tags[0]) != 1) {
                           array_push($cleaned_form_tags, preg_replace("/-/", "", $form_tag));                   
                       }
                   }
                   array_push($cleaned_form_tags, strtoupper(preg_replace("/-/", "", $print_tag)));

                   $ptag = preg_replace("/-/", "", $cleaned_form_tags);
                   wp_set_post_terms($post_id, $cleaned_form_tags, 'post_tag');
                   if ($print_tag != $print_tags[1]) {
                       $parts = preg_split('/-(\d+)$/', $print_tag, -1, PREG_SPLIT_DELIM_CAPTURE);
                       if ((count($parts) > 1) && ($parts[0] != "-")) {
                           update_post_meta($post_id, 'e_section', strtolower($parts[0]));
                           update_post_meta($post_id, 'e_section_page', $parts[1]);
                       }
                   }
               }

               if ((isset($_POST['print-tag-date'])) && ($_POST['print-tag-date'])) {
                   update_post_meta($post_id, 'e_section_date', strftime("%Y-%m-%d", strtotime($_POST['print-tag-date'])));
                }
            }        
        }
    }

    function print_tags_load() {
        $print_tag_options = get_option('print_tag_options');
        $print_tags = array();
        for ($i=1; $i<=$print_tag_options['number_of_sections']; $i++) {
            for ($j=1; $j<=$print_tag_options['page_count_' . $i]; $j++) {
                $tag = $print_tag_options['section_name_' . $i] . $j;
                array_push($print_tags, $tag);
            }
        }
        $sections = get_option("e_sections_additional_sections", serialize(array()));
        $pages = get_option("e_sections_spectal_section_pages", 20);
                
        if (!is_array($sections)) {
            $sections = unserialize($sections);
        }        
        
        for ($x = 1; $x <= count($sections); $x++) {
            for ($i=1; $i<=$pages; $i++) {
                $tag = strtoupper($sections[$x]["name"]) . $i;
                array_push($print_tags, $tag);
            }
        }
        delete_option("dk-test");
       return array($print_tags, array());

    } 
}
?>
